import * as _backstage_plugin_auth_node from '@backstage/plugin-auth-node';
import { PassportOAuthAuthenticatorHelper, PassportProfile, OAuthAuthenticatorResult } from '@backstage/plugin-auth-node';
import * as _backstage_backend_plugin_api from '@backstage/backend-plugin-api';

/** @public */
declare const bitbucketServerAuthenticator: _backstage_plugin_auth_node.OAuthAuthenticator<{
    helper: PassportOAuthAuthenticatorHelper;
    host: string;
}, PassportProfile>;

/** @public */
declare const authModuleBitbucketServerProvider: _backstage_backend_plugin_api.BackendFeature;

/**
 * Available sign-in resolvers for the Bitbucket Server auth provider.
 *
 * @public
 */
declare namespace bitbucketServerSignInResolvers {
    /**
     * Looks up the user by matching their email to the entity email.
     */
    const emailMatchingUserEntityProfileEmail: _backstage_plugin_auth_node.SignInResolverFactory<OAuthAuthenticatorResult<PassportProfile>, {
        dangerouslyAllowSignInWithoutUserInCatalog?: boolean | undefined;
    } | undefined>;
}

export { bitbucketServerAuthenticator, bitbucketServerSignInResolvers, authModuleBitbucketServerProvider as default };
