'use strict';

var pluginAuthNode = require('@backstage/plugin-auth-node');
var zod = require('zod');

exports.bitbucketServerSignInResolvers = void 0;
((bitbucketServerSignInResolvers2) => {
  bitbucketServerSignInResolvers2.emailMatchingUserEntityProfileEmail = pluginAuthNode.createSignInResolverFactory({
    optionsSchema: zod.z.object({
      dangerouslyAllowSignInWithoutUserInCatalog: zod.z.boolean().optional()
    }).optional(),
    create(options = {}) {
      return async (info, ctx) => {
        const { profile } = info;
        if (!profile.email) {
          throw new Error(
            "Login failed, user profile does not contain an email"
          );
        }
        return ctx.signInWithCatalogUser(
          {
            filter: {
              "spec.profile.email": profile.email
            }
          },
          {
            dangerousEntityRefFallback: options?.dangerouslyAllowSignInWithoutUserInCatalog ? { entityRef: { name: profile.email } } : void 0
          }
        );
      };
    }
  });
})(exports.bitbucketServerSignInResolvers || (exports.bitbucketServerSignInResolvers = {}));
//# sourceMappingURL=resolvers.cjs.js.map
